<?php
    include __DIR__.DS."api.class.php";
    class EverestPanel_Module extends ServerModule
    {
        private $api;
        function __construct($server,$options=[])
        {
            $this->_name = __CLASS__;
            $this->force_setup  = true;  
            parent::__construct($server,$options);
        }

        protected function define_server_info($server=[])
        {
            /*
            if(!class_exists("SampleApi")) include __DIR__.DS."api.class.php";
            $this->api = new SampleApi(
                $server["name"],
                $server["ip"],
                $server["username"],
                $server["password"],
                $server["access_hash"],
                $server["port"],
                $server["secure"],
                $server["port"]
            );
            */
        }

        public function testConnect(){

            try
            {
                $connect    = 'OK';  #$this->api->checkConnect();
            }
            catch(Exception $e){
                $this->error = $e->getMessage();
                return false;
            }

            if($connect != 'OK'){
                $this->error = $connect;
                return false;
            }

            return true;
        }

        public function ResBroadcasterTemplates($params){

            $server    = Products::get_server($params->order['options']['server_id']);
            if($server['secure']=='1')
            {
                $secure='https';
            }
            else{
                $secure='http';
            }

            $api = "/reseller/broadcasters-gettemplates";
            $url = $secure . "://" . $server['name'] . "/api" . $api;

            $ch = curl_init();
            $token = $server['access_hash'];

            $dataArray = ['reseller_api_token' => $token];

            $data = http_build_query($dataArray);

            $getUrl = $url."?".$data;


            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token"
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $getUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);


            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);

            $json_response = json_decode($output, true); 

            $template = array();
            $template[0] = 'No Template';
            foreach($json_response["templates"] as $response){
                $template[$response["id"]] = $response["name"];
            }

            return $template;

        }

        public function BroadcasterTemplates($params){

            $server    = Products::get_server($params->order['options']['server_id']);
            if($server['secure']=='1')
            {
                $secure='https';
            }
            else{
                $secure='http';
            }

            $api = "/templates/broadcasters";
            $url = $secure . "://" . $server['name'] . "/api" . $api;

            $ch = curl_init();
            $token = $server['access_hash'];

            $dataArray = ['api_token' => $token];

            $data = http_build_query($dataArray);

            $getUrl = $url."?".$data;


            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token"
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $getUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);


            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);

            $json_response = json_decode($output, true); 

            $template = array();
            $template[0] = 'No Template';
            foreach($json_response["data"] as $response){
                $template[$response["id"]] = $response["name"];
            }

            return $template;

        }

        public function ResTemplates($params){

            $server    = Products::get_server($params->order['options']['server_id']);
            if($server['secure']=='1')
            {
                $secure='https';
            }
            else{
                $secure='http';
            }

            $api = "/templates/resellers";
            $url = $secure . "://" . $server['name'] . "/api" . $api;

            $ch = curl_init();
            $token = $server['access_hash'];

            $dataArray = ['api_token' => $token];

            $data = http_build_query($dataArray);

            $getUrl = $url."?".$data;


            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token"
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $getUrl);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);


            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);

            $json_response = json_decode($output, true); 

            $template = array();
            $template[0] = 'No Template';
            foreach($json_response["data"] as $response){
                $template[$response["id"]] = $response["name"];
            }

            return $template;

        }

        public function config_options($data=[])
        {
            $ResBroadcasterTemplates=self::ResBroadcasterTemplates($this); 
            $BroadcasterTemplates=self::BroadcasterTemplates($this); 
            $ResTemplates=self::ResTemplates($this); 

            $customjs = '
               <script>
                  $(document).ready(function(){
                        everestpanelinit();
                  });
               </script>
               <style>
                  .vhide{visibility: hidden;}
                  .vshow{visibility: visible;}
               </style>
            ';

            return [
                'account_type'          => [ 
                    'name'              => "Account type",
                    'description'       => "Select Account type",
                    'type'              => 'dropdown',
                    'options' => array(
                        'broadcasters' => 'Broadcasters',
                        'resellers' => 'Resellers',
                    ),
                    'value'             => isset($data["account_type"]) ? $data["account_type"] : "",
                ],
                "broadcasters_template" => [ 
                    'name'              => "Broadcasters template",
                    'description'       => $customjs." Created in Everest Panel admin area",
                    'type'              => "dropdown",
                    'options'           => $BroadcasterTemplates,
                    'value'             => isset($data["broadcasters_template"]) ? $data["broadcasters_template"] : "",
                ],
                "resellers_template"          => [
                    'name'              => "Resellers template",
                    'description'       => "Created in Everest Panel admin area",
                    'type'              => "dropdown",
                    'options'           => $ResTemplates,
                    'value'             => isset($data["resellers_template"]) ? $data["resellers_template"] : "",
                ],
                'owner'          => [
                    'name'              => "Owner",
                    'type'              => 'text',
                    "description" => "0 for admin, if reseller, sent reseller ID",
                    'value'             => isset($data["owner"]) ? $data["owner"] : "",
                ],
                "resbroadcasters_template"          => [
                    'name'              => "Reseller Broadcasters template",
                    'description'       => "Created in Everest Panel admin area",
                    'type'              => "dropdown",
                    'options'           => $ResBroadcasterTemplates,
                    'value'             => isset($data["resbroadcasters_template"]) ? $data["resbroadcasters_template"] : "",
                ],   
                'server_type'          => [
                    'name'              => "Server type",
                    'description'       => "Select Server type",
                    'type'              => 'dropdown',
                    'options'           =>  array(
                    'icecast' => 'Icecast',
                    'shoutcast2' => 'Shoutcast 2',
                        ),
                    'value'             => isset($data["server_type"]) ? $data["server_type"] : "",
                ],
                "radio_stations_limit"          => [
                    'name'              => "Radio stations limit",
                    'description'       => "0 for unlimited",
                    'type'              => "text",
                    'value'             => isset($data["radio_stations_limit"]) ? $data["radio_stations_limit"] : "",
                ],
                "radio_channels_limit"          => [
                    'name'              => "Radio channels limit",
                    'description'       => "0 for unlimited",
                    'type'              => "text",
                    'value'             => isset($data["radio_channels_limit"]) ? $data["radio_channels_limit"] : "",
                ],
                "listeners_limit"          => [
                    'name'              => "Radio channels limit",
                    'description'       => "0 for unlimited",
                    'type'              => "text",
                    'value'             => isset($data["listeners_limit"]) ? $data["listeners_limit"] : "",
                ],
                'maximum_bitrate'          => [
                    'name'              => "Maximum bitrate",
                    'description'       => "Select Maximum bitrate",
                    'type'              => 'dropdown',
                    'options'           =>  array(
                        '0' => 'Unlimited',
                        '24' => '24 kbps',
                        '32' => '32 kbps',
                        '64' => '64 kbps',
                        '96' => '96 kbps',
                        '128' => '128 kbps',
                        '192' => '192 kbps',
                        '256' => '256 kbps',
                        '320' => '320 kbps',
                    ),
                    'value'             => isset($data["maximum_bitrate"]) ? $data["maximum_bitrate"] : "",
                ],
                "Disk_quota"          => [  
                    'name'              => "Disk quota (megabytes)",
                    'description'       => "0 for unlimited",
                    'type'              => "text",
                    "Size"         => "50",
                    'value'             => isset($data["Disk_quota"]) ? $data["Disk_quota"] : "",
                   
                ],
                "Traffic_per_month"          => [   
                    'name'              => "Traffic per month (megabytes)",
                    'description'       => "0 for unlimited",
                    'type'              => "text",
                    "Size"         => "50",
                    'value'             => isset($data["Traffic_per_month"]) ? $data["Traffic_per_month"] : "",
                ],
                "Enable_Auto_DJ"    => [    
                    'name'         => "Enable Auto DJ",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],  
                    'value'             => isset($data["Enable_Auto_DJ"]) ? $data["Enable_Auto_DJ"] : "",    
                ],
                "Allow_Recording"    => [
                    'name'         => "Allow Recording",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],      
                    'value'             => isset($data["Allow_Recording"]) ? $data["Allow_Recording"] : "",    
                ],
                "Allow_Youtube_Downloader"    => [
                    'name'              => "Allow Youtube Downloader",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],       
                    'value'             => isset($data["Allow_Youtube_Downloader"]) ? $data["Allow_Youtube_Downloader"] : "", 
                ],
                "Allow_Youtube_streaming"    => [
                    'name'              => "Allow Youtube streaming (increased CPU load)",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],      
                    'value'             => isset($data["Allow_Youtube_streaming"]) ? $data["Allow_Youtube_streaming"] : "",    
                ],
                 "Allow_Facebook_streaming"    => [
                    'name'              => "Allow Facebook streaming (increased CPU load)",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],       
                    'value'             => isset($data["Allow_Facebook_streaming"]) ? $data["Allow_Facebook_streaming"] : "", 
                ],
                "Allow_Telegram_streaming"    => [
                    'name'              => "Allow Telegram streaming (increased CPU load)",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],    
                    'value'             => isset($data["Allow_Telegram_streaming"]) ? $data["Allow_Telegram_streaming"] : "", 
                ],
                "Allow_Custom_streaming"    => [
                    'name'              => "Allow Custom streaming (increased CPU load)",
                    "type"         => "dropdown",
                    'options'           => [
                        '1' => 'Yes',
                        '0' => 'No',
                    ],  
                    'value'             => isset($data["Allow_Custom_streaming"]) ? $data["Allow_Custom_streaming"] : "",
                ],

            ];
        }

        public function create($domain = '',array $order_options=[])
        {
            self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    $this,
                    '0.0.0.0',
                    date('Y-m-d')
                );

            $class=new ApiClass();
            return $class->create($this);
        }

        public function suspend()
        {
            self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    $this,
                    '0.0.0.0',
                    date('Y-m-d')
                );

            $class=new ApiClass();
            return $class->suspend($this);
        }

        public function unsuspend()
        {
            self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    $this,
                    '0.0.0.0',
                    date('Y-m-d')
                );

            $class=new ApiClass();
            return $class->unsuspend($this);
        }

        public function terminate()
        {
            self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    $this,
                    '0.0.0.0',
                    date('Y-m-d')
                );

            $class=new ApiClass();
            return $class->terminate($this);
        }

        
        public function listAccounts(){

            self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    $this,
                    '0.0.0.0',
                    date('Y-m-d')
                );

            $class=new ApiClass();
            return $class->listAccounts($this);
        }

        public function apply_updowngrade($orderopt=[],$product=[]){

            self::save_log(
                    'Servers',
                    $this->_name,
                    __FUNCTION__,
                    $this,
                    '0.0.0.0',
                    date('Y-m-d')
                );

            $class=new ApiClass();
            return $class->apply_updowngrade($this);
        }

        public function use_adminArea_SingleSignOn()
        {
            $class=new ApiClass();
            $api_result= $class->AdminSingleSignOn($this);

            if($api_result['success'] == false){
                return $api_result['errorMsg'];
            }

            Utility::redirect($api_result['redirectTo']);

            echo "Redirecting...";
        }

        public function use_clientArea_SingleSignOn()
        {
            $class=new ApiClass();
            $api_result= $class->ClientAreaSingleSignOn($this);

            if($api_result['success'] == false){
                return $api_result['errorMsg'];
            }

            Utility::redirect($api_result['redirectTo']);

            echo "Redirecting...";
        }

        public function clientArea()
        {
            $class=new ApiClass();
            return $class->clientArea($this);
        }

        public function clientArea_buttons()
        {
            $buttons    = [];

            if($this->page && $this->page != "home")
            {
                $buttons['home'] = [
                    'text' => $this->lang["turn-back"],
                    'type' => 'page-loader',
                ];
            }
            else
            {

                $buttons['custom_transaction'] = [
                    'text'  => 'Run Transaction',
                    'type'  => 'transaction',
                ];

                $buttons['another'] = [
                    'text'  => 'Another Page',
                    'type'  => 'page-loader',
                ];

                $buttons['custom_function'] = [
                    'text'  => 'Open Function',
                    'type'  => 'function',
                    'target_blank' => true,
                ];

                $buttons['another-link'] = [
                    'text'      => 'Another link',
                    'type'      => 'link',
                    'url'       => 'https://www.google.com',
                    'target_blank' => true,
                ];
            }

            return $buttons;
        }

    }