<?php
class ApiClass {

    public function GetTemplatesRes($params,$templateid){

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = "/reseller/broadcasters-gettemplates";
        $url = $secure . "://" . $server['name'] . "/api" . $api;

        $ch = curl_init();
        $token = $server['access_hash'];
        $dataArray = ['reseller_api_token' => $token];

        $data = http_build_query($dataArray);

        $getUrl = $url."?".$data;


        $ch = curl_init();
        curl_setopt($ch,
            CURLOPT_HTTPHEADER,
            array(
                'Content-Type: application/x-www-form-urlencoded',
                 "token: $token"
                )
        );
        curl_setopt($ch, CURLOPT_URL, $getUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if (curl_errno($ch)) {
            return 'Curl error: ' . curl_error($ch);
        }
        curl_close($ch);
        $json_response = json_decode($output, true);

        $template = array();
        $template[0] = 'No Template';
        foreach($json_response["templates"] as $response){
            if($response["id"] == $templateid){
                return $response;
            }
        }

    }

    public function GetTemplates($params,$type,$templateid){

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = "/templates/$type";
        $url = $secure . "://" . $server['name'] . "/api" . $api;

        $ch = curl_init();
        $token = $server['access_hash'];
        $dataArray = ['api_token' => $token];

        $data = http_build_query($dataArray);

        $getUrl = $url."?".$data;


        $ch = curl_init();
        curl_setopt($ch,
            CURLOPT_HTTPHEADER,
            array(
                'Content-Type: application/x-www-form-urlencoded',
                 "token: $token"
                )
        );
        curl_setopt($ch, CURLOPT_URL, $getUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if (curl_errno($ch)) {
            return 'Curl error: ' . curl_error($ch);
        }
        curl_close($ch);
        $json_response = json_decode($output, true);

        $template = array();
        $template[0] = 'No Template';
        foreach($json_response["data"] as $response){
            if($response["id"] == $templateid){
                return $response;
            }
        }

    }

    public function create($params)
    {
        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $servertype = $params->options['creation_info']['server_type'];

        $maxbitrate = $params->options['creation_info']['maximum_bitrate'];

        $userid = $params->user['id'];

        if(!empty($params->config['user']))
        {
            $mainusername = $params->config['user'];
        }
        else
        {
            function generateRandomString($length = 8) {
                return substr(str_shuffle(str_repeat($x='abcdefghijklmnopqrstuvwxyz', ceil($length/strlen($x)) )),1,$length);
            }

            $mainusername = generateRandomString();
        }
        
        $serviceid = $params->order['id']; 
        $panelowner = $params->options['creation_info']['owner'];
        $user_type = $params->options['creation_info']['account_type'];

        if($panelowner != 0){
            $templateid = $params->options['creation_info']['resbroadcasters_template'];
        }elseif($user_type == 'broadcasters'){
            $templateid = $params->options['creation_info']['broadcasters_template'];
        }else{
            $templateid = $params->options['creation_info']['resellers_template'];
        }

        if($panelowner != 0){
            $templatesfields = self::GetTemplatesRes($params,$templateid);
        }else{
            $templatesfields = self::GetTemplates($params,$user_type,$templateid);
        }


        $api = $user_type == 'broadcasters' ? "/broadcasters/store" : "/resellers/store";
        $url = $secure . "://" . $server['name'] . "/api" . $api;


        $return = "";
        $token = $server['access_hash'];

        try {
            $username = urlencode($mainusername);
            $password = urlencode($server['password']);

            $channel_name = $params->user['company_name'] != "" ? $params->user['company_name'] : $username;

            if (in_array('curl', get_loaded_extensions())) {

                $postParams['name'] = $mainusername;
                $postParams['station_name'] = $channel_name;
                $postParams['email'] = $params->user['email'];
                $postParams['password'] = $password;


                if($templateid == 0){

                    if($user_type == 'resellers'){
                     $postParams['allowed_radio_accounts'] = $params->options['creation_info']['radio_channels_limit'];
                     $postParams['company_name'] = $channel_name;
                    }

                    $postParams['listeners'] = $params->options['creation_info']['listeners_limit'];
                    $postParams['disk'] = $params->options['creation_info']['Disk_quota'];
                    $postParams['bitrate'] = $maxbitrate;
                    $postParams['traffic'] = $params->options['creation_info']['Traffic_per_month'];


                    $usautodj = $params->options['creation_info']['Enable_Auto_DJ'];
                    $usallowrecording = $params->options['creation_info']['Allow_Recording'];
                    $usyoutubedownload = $params->options['creation_info']['Allow_Youtube_Downloader'];
                    $usyoutubestreaming = $params->options['creation_info']['Allow_Youtube_streaming'];
                    $usfacebooks = $params->options['creation_info']['Allow_Facebook_streaming'];
                    $ustelegrem = $params->options['creation_info']['Allow_Telegram_streaming'];
                    $uscustoms = $params->options['creation_info']['Allow_Custom_streaming'];

                    $youtube_download = $usyoutubedownload;

                    $youtube = $usyoutubestreaming;

                    $facebook = $usfacebooks;

                    $telegram = $ustelegrem;

                    $autodj = $usautodj;

                    $custom = $uscustoms;

                    $record = $usallowrecording;

                    if($user_type == 'broadcasters'){
                        $postParams['stations'] = $params->options['creation_info']['radio_stations_limit'];
                        $postParams['channels'] = $params->options['creation_info']['radio_channels_limit'];
                        $postParams['youtube'] = $youtube;
                        $postParams['facebook'] = $facebook;
                        $postParams['telegram'] = $telegram;
                        $postParams['owner'] = $panelowner;
                        $postParams['autodj'] = $autodj;
                        $postParams['custom'] = $custom;
                        $postParams['server_type'] = $servertype;
                    }
                    $postParams['stations_limit'] = $params->options['creation_info']['radio_stations_limit'];
                    $postParams['channels_limit'] = $params->options['creation_info']['radio_channels_limit'];

                    $postParams['record'] = $record;
                    $postParams['youtube_download'] = $youtube_download;


                }else{

                    if($user_type == 'resellers'){
                        $postParams['allowed_radio_accounts'] = $templatesfields['allowed_radio_accounts'];
                        $postParams['company_name'] = $channel_name;
                    }
                    $postParams['listeners'] = $templatesfields['listeners_limit'];
                    $postParams['disk'] = $templatesfields['disk_quota'];
                    $postParams['bitrate'] = $templatesfields['bitrate'];
                    $postParams['traffic'] = $templatesfields['traffic_per_month'];

                    if($user_type == 'broadcasters'){
                        $postParams['stations'] = $templatesfields['stations_limit'];
                        $postParams['channels'] = $templatesfields['channels_limit'];
                        $postParams['youtube'] = $templatesfields['youtube'];
                        $postParams['facebook'] = $templatesfields['facebook'];
                        $postParams['telegram'] = $templatesfields['telegram'];
                        $postParams['owner'] = $panelowner;
                        $postParams['autodj'] = $templatesfields['autodj'];
                        $postParams['custom'] = $templatesfields['custom'];
                        $postParams['server_type'] = $templatesfields['server_type'];
                    }
                    $postParams['stations_limit'] = $templatesfields['stations_limit'];
                    $postParams['channels_limit'] = $templatesfields['channels_limit'];

                    if(!empty($templatesfields['record'])){
                        $record = $templatesfields['record'];
                    }else{
                        $record = 0;
                    }

                    if(!empty($templatesfields['youtube_download'])){
                        $youtube_download = $templatesfields['youtube_download'];
                    }else{
                        $youtube_download = 0;
                    }

                    $postParams['record'] = $record;
                    $postParams['youtube_download'] = $youtube_download;

                }

                /*$websiteurl = $params["customfields"]["Website URL"];
                if(!empty($websiteurl)){
                    $givenweburl = $websiteurl;
                }else{*/
                    $givenweburl = "nourlgiven.com";
                //}
                $postParams['website_url'] = $givenweburl;

                if($panelowner != 0){
                    $postParams['reseller_api_token'] = $token;
                }else{
                    $postParams['api_token'] = $token;
                }

                $postString = "";
                foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
                rtrim($postString, '&');

                $ch = curl_init();
                curl_setopt($ch,
                    CURLOPT_HTTPHEADER,
                    array(
                        'Content-Type: application/x-www-form-urlencoded',
                         "token: $token",
                         "reseller_name: $mainusername"
                        )
                );
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HEADER, false);
                //curl_setopt($ch, CURLOPT_POST, count($postString));
                curl_setopt($ch, CURLOPT_POSTFIELDS, $postString);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

                $output = curl_exec($ch);

                if (curl_errno($ch)) {
                    return 'Curl error: ' . curl_error($ch);
                }

                curl_close($ch);

                $json_response = json_decode($output, true);
                //print_r($json_response); exit;
                $getstatus = $json_response["status"];
                $geterror = $json_response["error"];

                if ($getstatus == 'error') {
                    return $json_response["message"];
                }elseif(!empty($geterror)){
                    return $json_response["error"]["name"][0];
                }else{

                    return [
                        'username' => $mainusername,
                        'password' => $password,
                    ];
                }

            } else {

                return "Error : Curl is not installed on this server";
            }

        } catch (Exception $e) {

            return $e->getMessage();
        }

        return 'success';
    }

    public function suspend($params) 
    { 
        $username = $params->config['user']; 
        $serviceid = $params->order['id']; 
        $user_type = $params->options['creation_info']['account_type'];

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = $user_type == 'broadcasters' ? "/broadcasters/".$username."/update-status" : "/resellers/".$username."/update-status";

        $url = $secure . "://" . $server['name'] . "/api" . $api;

        $ch = curl_init();
        $token = $server['access_hash'];

        $panelowner = $params->options['creation_info']['owner'];

        if($panelowner != 0){
            $dataArray = ['reseller_api_token' => $token];
        }else{
            $dataArray = ['api_token' => $token];
        }

        $data = http_build_query($dataArray);

        $getUrl = $url."?".$data;

        $ch = curl_init();
        curl_setopt($ch,
            CURLOPT_HTTPHEADER,
            array(
                'Content-Type: application/x-www-form-urlencoded',
                 "token: $token",
                 "name: $username"
                )
        );
        curl_setopt($ch, CURLOPT_URL, $getUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if (curl_errno($ch)) {
            return 'Curl error: ' . curl_error($ch);
        }

        curl_close($ch);

        $json_response = json_decode($output, true);
        print_r($json_response); exit;
        $getstatus = $json_response["status"];
        if($getstatus == "success"){
            return 'success';
        }else{
            return 'error';
        }

    }

    public function unsuspend($params)
    {
        $username = $params->config['user'];
        $serviceid = $params->order['id']; 
        $user_type = $params->options['creation_info']['account_type'];

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = $user_type == 'broadcasters' ? "/broadcasters/$username/update-status" : "/resellers/$username/update-status";

        $url = $secure . "://" . $server['name'] . "/api" . $api;

        $ch = curl_init();
        $token = $server['access_hash'];

        $panelowner = $params->options['creation_info']['owner'];

        if($panelowner != 0){
            $dataArray = ['reseller_api_token' => $token];
        }else{
            $dataArray = ['api_token' => $token];
        }

        $data = http_build_query($dataArray);

        $getUrl = $url."?".$data;

        $ch = curl_init();
        curl_setopt($ch,
            CURLOPT_HTTPHEADER,
            array(
                'Content-Type: application/x-www-form-urlencoded',
                 "token: $token",
                 "name: $username"
                )
        );
        curl_setopt($ch, CURLOPT_URL, $getUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if (curl_errno($ch)) {
            return 'Curl error: ' . curl_error($ch);
        }

        curl_close($ch);

        $json_response = json_decode($output, true);
        print_r($json_response); exit;
        $getstatus = $json_response["status"];
        if($getstatus == "success"){
            return 'success';
        }else{
            return 'error';
        }
    }

    public function terminate($params)
    {
        $username = $params->config['user'];
        $serviceid = $params->order['id']; 
        $user_type = $params->options['creation_info']['account_type'];

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = $user_type == 'broadcasters' ? "/broadcasters/$username/delete" : "/resellers/$username/delete";

        $url = $secure . "://" . $server['name'] . "/api" . $api;

        $ch = curl_init();
        $token = $server['access_hash'];

        $panelowner = $params->options['creation_info']['owner'];

        if($panelowner != 0){
            $dataArray = ['reseller_api_token' => $token];
        }else{
            $dataArray = ['api_token' => $token];
        }

        $data = http_build_query($dataArray);

        $getUrl = $url."?".$data;

        $ch = curl_init();
        curl_setopt($ch,
            CURLOPT_HTTPHEADER,
            array(
                'Content-Type: application/x-www-form-urlencoded',
                 "token: $token",
                 "name: $username"
                )
        );
        curl_setopt($ch, CURLOPT_URL, $getUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if (curl_errno($ch)) {
            return 'Curl error: ' . curl_error($ch);
        }

        curl_close($ch);

        $json_response = json_decode($output, true);
        print_r($json_response); exit;
        $getstatus = $json_response["status"];
        if($getstatus == "success"){
            return 'success';
        }else{
            return 'error';
        }
    }

    public function AdminSingleSignOn($params)
    {
        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        try {

            $token = $server['access_hash'];
            $api = "/generate-login-token";
            $url = $secure . "://" . $server['name'] . "/api" . $api;

            $panelowner = $server['username'];

            if($panelowner != 'admin'){
                $postParams['reseller_api_token'] = $token;
                $postParams['user_type'] = 'reseller';
                $postParams['name'] = $server["username"];
            }else{
                $postParams['api_token'] = $token;
                $postParams['user_type'] = 'admin';
                $postParams['name'] = 'admin';
            }

            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');


            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token",
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            //curl_setopt($ch, CURLOPT_POST, count($postString));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);

            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);

            $json_response = json_decode($output, true);

            $getstatus = $json_response["status"];

            if($getstatus == 'success'){
                    $login_code = $json_response["login_code"];
                    $token = $server['access_hash'];
                    $api2 = "/login-by-code";
                    $url2 = $secure . "://" . $server['name'] . "/api" . $api2;


                    $dataArray = ['login_code' => $login_code];

                    $data = http_build_query($dataArray);

                    $getUrl = $url2."?".$data;


                    $ch2 = curl_init();
                    curl_setopt($ch2,
                        CURLOPT_HTTPHEADER,
                        array(
                            'Content-Type: application/x-www-form-urlencoded',
                             "token: $token",
                            )
                    );
                    curl_setopt($ch2, CURLOPT_URL, $getUrl);
                    curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);
                    curl_setopt($ch2, CURLOPT_HEADER, false);
                    curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);

                    $output = curl_exec($ch2);

                    if (curl_errno($ch2)) {
                        return 'Curl error: ' . curl_error($ch2);
                    }
                    curl_close($ch2);

                if($output){
                    print_r($output); die;
                }else{
                    return array(
                        'success' => false,
                    );
                }


            }else{
                return array(
                    'success' => false,
                );
            }

        } catch (Exception $e) {
            return array(
                'success' => false,
                'errorMsg' => $e->getMessage(),
            );
        }
    }

    public function ClientAreaSingleSignOn($params)
    {
        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        try {

            $user_type = $params->options['creation_info']['account_type'];
            $name = $user_type == 'broadcasters' ? "broadcaster" : "reseller";
            $token = $server['access_hash'];
            $api = "/generate-login-token";
            $url = $secure . "://" . $server['name'] . "/api" . $api;

            $postParams['user_type'] = $name;
            $postParams['name'] = $params->config['user'];

            $panelowner = $params->options['creation_info']['owner'];

            if($panelowner != 0){
                $postParams['reseller_api_token'] = $token;
                $postParams['name'] = $params->config['user'];
            }else{
                $postParams['api_token'] = $token;
            }

            $postString = "";
            foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
            rtrim($postString, '&');


            $ch = curl_init();
            curl_setopt($ch,
                CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/x-www-form-urlencoded',
                     "token: $token",
                    )
            );
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_HEADER, false);
            //curl_setopt($ch, CURLOPT_POST, count($postString));
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postString);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            $output = curl_exec($ch);

            if (curl_errno($ch)) {
                return 'Curl error: ' . curl_error($ch);
            }

            curl_close($ch);

            $json_response = json_decode($output, true);

            $getstatus = $json_response["status"];

            if($getstatus == 'success'){
                $login_code = $json_response["login_code"];
                $token = $server['access_hash'];
                $api2 = "/login-by-code";
                $url2 = $secure . "://" . $server['name'] . "/api" . $api2;

                $dataArray = ['login_code' => $login_code];

                $data = http_build_query($dataArray);

                $getUrl = $url2."?".$data;


                $ch2 = curl_init();
                curl_setopt($ch2,
                    CURLOPT_HTTPHEADER,
                    array(
                        'Content-Type: application/x-www-form-urlencoded',
                         "token: $token",
                        )
                );
                curl_setopt($ch2, CURLOPT_URL, $getUrl);
                curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch2, CURLOPT_HEADER, false);
                curl_setopt($ch2, CURLOPT_RETURNTRANSFER, true);

                $output = curl_exec($ch2);

                if (curl_errno($ch2)) {
                    return 'Curl error: ' . curl_error($ch2);
                }
                curl_close($ch2);

            if($output){
                print_r($output);die;
            }else{
                return array(
                    'success' => false,
                );
            }


            }else{
                return array(
                    'success' => false,
                );
            }

        } catch (Exception $e) {

            return array(
                'success' => false,
                'errorMsg' => $e->getMessage(),
            );
        }
    }

    public function listAccounts($params)
    {

        $accounts = [];
        $serviceid = $params->order['id']; 
        $user_type = $params->options['creation_info']['account_type'];

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = "/broadcasters";
        $url = $secure . "://" . $server['name'] . "/api" . $api;


        $ch = curl_init();
        $token = $server['access_hash'];

        $panelowner = $params->options['creation_info']['owner'];

        if($panelowner != 0){
            $dataArray = ['reseller_api_token' => $token];
        }else{
            $dataArray = ['api_token' => $token];
        }

        $data = http_build_query($dataArray);

        $getUrl = $url."?".$data;

        $ch = curl_init();
        curl_setopt($ch,
            CURLOPT_HTTPHEADER,
            array(
                'Content-Type: application/x-www-form-urlencoded',
                 "token: $token",
                )
        );
        curl_setopt($ch, CURLOPT_URL, $getUrl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $output = curl_exec($ch);

        if (curl_errno($ch)) {
            return 'Curl error: ' . curl_error($ch);
        }

        curl_close($ch);

        $json_response = json_decode($output, true); 
        $allaccounts = $json_response["data"];

        foreach($allaccounts as $allaccount){
            $accounts[] = [
                    'email' => $allaccount['email'],
                    'username' => $allaccount['name'],
                    'password' => $allaccount['ftp'],
                    'uniqueIdentifier' => $allaccount['name'],
                    'configoption1' => $user_type,
                    'primaryip' => '1.2.3.4',
                    'created' => $allaccount['created_at'],
                    'status' => $allaccount['status'],
                ];
        }
        print_r($accounts); exit;
        $getstatus = $json_response["status"];
        if($getstatus == "success"){
            return [
                'success'  => true,
                'accounts' => $accounts,
            ];
        }else{
            return [
                'success'  => false,
            ];
        }

    }

    public function apply_updowngrade($params)
    {
        $servertype = $params->options['creation_info']['server_type'];
        $maxbitrate = $params->options['creation_info']['maximum_bitrate'];

        $userid = $params->user['id'];
        $mainusername = $params->config['user'];


        $serviceid = $params->order['id']; 
        $panelowner = $params->options['creation_info']['owner'];
        $user_type = $params->options['creation_info']['account_type'];

        if($panelowner != 0){
            $templateid = $params->options['creation_info']['resbroadcasters_template'];
        }elseif($user_type == 'broadcasters'){
            $templateid = $params->options['creation_info']['broadcasters_template'];
        }else{
            $templateid = $params->options['creation_info']['resellers_template'];
        }

        if($panelowner != 0){
            $templatesfields = self::GetTemplatesRes($params,$templateid);
        }else{
            $templatesfields = self::GetTemplates($params,$user_type,$templateid);
        }

        $server    = Products::get_server($params->options['server_id']);

        if($server['secure']=='1')
        {
            $secure='https';
        }
        else{
            $secure='http';
        }

        $api = $user_type == 'broadcasters' ? "/broadcasters/update" : "/resellers/update";
        $url = $secure . "://" . $server['name'] . "/api" . $api;


        $return = "";
        $token = $server['access_hash'];

        try {
            $username = urlencode($mainusername);
            $password = urlencode($server['password']);

            $channel_name = $params->user['company_name'] != "" ? $params->user['company_name'] : $username;

            if (in_array('curl', get_loaded_extensions())) {

                $postParams['name'] = $mainusername;
                $postParams['station_name'] = $channel_name;
                $postParams['email'] = $params->user['email'];
                $postParams['password'] = $password;

                if($templateid == 0){

                    if($user_type == 'resellers'){
                     $postParams['allowed_radio_accounts'] = $params->options['creation_info']['radio_channels_limit'];
                     $postParams['company_name'] = $channel_name;
                    }

                    $postParams['listeners'] = $params->options['creation_info']['listeners_limit'];
                    $postParams['disk'] = $params->options['creation_info']['Disk_quota'];
                    $postParams['bitrate'] = $maxbitrate;
                    $postParams['traffic'] = $params->options['creation_info']['Traffic_per_month'];


                    $usautodj = $params->options['creation_info']['Enable_Auto_DJ'];
                    $usallowrecording = $params->options['creation_info']['Allow_Recording'];
                    $usyoutubedownload = $params->options['creation_info']['Allow_Youtube_Downloader'];
                    $usyoutubestreaming = $params->options['creation_info']['Allow_Youtube_streaming'];
                    $usfacebooks = $params->options['creation_info']['Allow_Facebook_streaming'];
                    $ustelegrem = $params->options['creation_info']['Allow_Telegram_streaming'];
                    $uscustoms = $params->options['creation_info']['Allow_Custom_streaming'];


                    $youtube_download = $usyoutubedownload;

                    $youtube = $usyoutubestreaming;

                    $facebook = $usfacebooks;

                    $telegram = $ustelegrem;

                    $autodj = $usautodj;

                    $custom = $uscustoms;

                    $record = $usallowrecording;

                    if($user_type == 'broadcasters'){
                        $postParams['stations'] = $params->options['creation_info']['radio_stations_limit'];
                        $postParams['channels'] = $params->options['creation_info']['radio_channels_limit'];
                        $postParams['youtube'] = $youtube;
                        $postParams['facebook'] = $facebook;
                        $postParams['telegram'] = $telegram;
                        $postParams['owner'] = $panelowner;
                        $postParams['autodj'] = $autodj;
                        $postParams['custom'] = $custom;
                        $postParams['server_type'] = $servertype;
                    }

                    $postParams['stations_limit'] = $params->options['creation_info']['radio_stations_limit'];
                    $postParams['channels_limit'] = $params->options['creation_info']['radio_channels_limit'];

                    $postParams['record'] = $record;
                    $postParams['youtube_download'] = $youtube_download;
                }else{

                    if($user_type == 'resellers'){
                        $postParams['allowed_radio_accounts'] = $templatesfields['allowed_radio_accounts'];
                        $postParams['company_name'] = $channel_name;
                    }

                    $postParams['listeners'] = $templatesfields['listeners_limit'];
                    $postParams['disk'] = $templatesfields['disk_quota'];
                    $postParams['bitrate'] = $templatesfields['bitrate'];
                    $postParams['traffic'] = $templatesfields['traffic_per_month'];

                    if($user_type == 'broadcasters'){
                        $postParams['stations'] = $templatesfields['stations_limit'];
                        $postParams['channels'] = $templatesfields['channels_limit'];
                        $postParams['youtube'] = $templatesfields['youtube'];
                        $postParams['facebook'] = $templatesfields['facebook'];
                        $postParams['telegram'] = $templatesfields['telegram'];
                        $postParams['owner'] = $panelowner;
                        $postParams['autodj'] = $templatesfields['autodj'];
                        $postParams['custom'] = $templatesfields['custom'];
                        $postParams['server_type'] = $templatesfields['server_type'];
                    }
                    $postParams['stations_limit'] = $templatesfields['stations_limit'];
                    $postParams['channels_limit'] = $templatesfields['channels_limit'];

                    if(!empty($templatesfields['record'])){
                        $record = $templatesfields['record'];
                    }else{
                        $record = 0;
                    }

                    if(!empty($templatesfields['youtube_download'])){
                        $youtube_download = $templatesfields['youtube_download'];
                    }else{
                        $youtube_download = 0;
                    }

                    $postParams['record'] = $record;
                    $postParams['youtube_download'] = $youtube_download;

                }

               /* $websiteurl = $params["customfields"]["Website URL"];
                if(!empty($websiteurl)){
                    $givenweburl = $websiteurl;
                }else{*/
                    $givenweburl = "nourlgiven.com";
                //}
                $postParams['website_url'] = $givenweburl;

                if($panelowner != 0){
                    $postParams['reseller_api_token'] = $token;
                }else{
                    $postParams['api_token'] = $token;
                }

                $postString = "";
                foreach($postParams as $key=>$value) { $postString .= $key.'='.$value.'&'; }
                rtrim($postString, '&');

                $ch = curl_init();
                curl_setopt($ch,
                    CURLOPT_HTTPHEADER,
                    array(
                        'Content-Type: application/x-www-form-urlencoded',
                         "token: $token",
                         "reseller_name: $mainusername"
                        )
                );
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch, CURLOPT_HEADER, false);
                //curl_setopt($ch, CURLOPT_POST, count($postString));
                curl_setopt($ch, CURLOPT_POSTFIELDS, $postString);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

                $output = curl_exec($ch);

                if (curl_errno($ch)) {
                    return 'Curl error: ' . curl_error($ch);
                }

                curl_close($ch);

                $json_response = json_decode($output, true);
                //print_r($json_response); exit;
                $getstatus = $json_response["status"];
                $geterror = $json_response["error"];

                if ($getstatus == 'error') {
                        return $json_response["message"];
                }elseif(!empty($geterror)){
                   return $json_response["error"]["name"][0];
                }else{

                    return [
                        'username' => $mainusername,
                        'password' => $password,
                    ];
                }

            } else {

                return "Error : Curl is not installed on this server";
            }

        } catch (Exception $e) {

            return $e->getMessage();
        }

        return 'success';
    }
}